=== debian/changelog ===
coq (8.4pl3dfsg-1) unstable; urgency=medium

  * New upstream release
  * Update README.Debian (Closes: #680248)

 -- Stéphane Glondu <glondu@debian.org>  Sun, 19 Jan 2014 16:16:36 +0100
