=== debian/changelog ===
coq (8.4pl4dfsg-3build2) xenial; urgency=medium

  * No-change rebuild against new ocaml ABIs

 -- Iain Lane <iain@orangesquash.org.uk>  Wed, 04 Nov 2015 10:40:32 +0000

coq (8.4pl4dfsg-3build1) xenial; urgency=medium

  * No-change rebuild against the new lablgtk2.

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@canonical.com>  Wed, 28 Oct 2015 17:55:01 +0100

coq (8.4pl4dfsg-3) unstable; urgency=medium

  * Move initial.coq to coq-theories, to avoid inconsistency errors on
    bytecode architectures

 -- Stéphane Glondu <glondu@debian.org>  Thu, 22 Oct 2015 23:38:19 +0200

coq (8.4pl4dfsg-2) unstable; urgency=medium

  * Fix compilation with OCaml 4.02

 -- Stéphane Glondu <glondu@debian.org>  Tue, 13 Oct 2015 17:26:06 +0200

coq (8.4pl4dfsg-1) unstable; urgency=medium

  * New upstream release (Closes: #755953)
  * Switch debian/copyright to Format 1.0
  * Bump Standards-Version to 3.9.5
  * Bump debhelper compat level to 9

 -- Stéphane Glondu <glondu@debian.org>  Sun, 27 Jul 2014 15:25:03 +0200
