=== debian/control ===
--- 
+++ 
@@ -6,9 +6,9 @@
  Ralf Treinen <treinen@debian.org>,
  Samuel Mimram <smimram@debian.org>,
  Stéphane Glondu <glondu@debian.org>
-Standards-Version: 3.9.2
+Standards-Version: 3.9.5
 Build-Depends:
- debhelper (>= 7.2.11~),
+ debhelper (>= 9),
  dh-ocaml (>= 0.9.5~),
  ocaml-nox (>= 4),
  ocaml-best-compilers,
@@ -71,8 +71,8 @@
 Architecture: all
 Depends: coq-${F:CoqABI}, ${misc:Depends}
 Recommends: coq (>= 8.0)
-Breaks: coq-doc (<= 8.0pl1.0-2), coq-libs (<< 8.2.pl1)
-Replaces: coq-libs (<< 8.2.pl1)
+Breaks: coq-doc (<= 8.0pl1.0-2), coq-libs (<< 8.2.pl1), coq (<< 8.4pl4dfsg-3)
+Replaces: coq-libs (<< 8.2.pl1), coq (<< 8.4pl4dfsg-3)
 Description: proof assistant for higher-order logic (theories)
  Coq is a proof assistant for higher-order logic, which allows the
  development of computer programs consistent with their formal
