=== debian/rules ===
--- 
+++ 
@@ -22,7 +22,7 @@
 
 PACKAGES := $(shell dh_listpackages)
 
-COQ_VERSION := 8.4pl3
+COQ_VERSION := 8.4pl4
 COQ_ABI := $(COQ_VERSION)+$(OCAML_ABI)
 
 CONFIGUREOPTS := --arch Linux --prefix /usr --mandir /usr/share/man \
@@ -36,13 +36,13 @@
   -e 's%@CoqABI@%$(COQ_ABI)%'
 
 %:
-	+dh --with ocaml $@
+	+dh $@ --with ocaml
 
 # There is already a file named "build" in upstream sources, so the
 # above rule is never called. We make it explicitly a phony rule here.
 .PHONY: build
 build:
-	+dh --with ocaml $@
+	+dh $@ --with ocaml
 
 .PHONY: override_dh_auto_configure
 override_dh_auto_configure:
